//package com.shcd.aistcp.config;
//
//import com.shcd.aistcp.entity.BoatInfoEntity;
//import com.shcd.aistcp.service.AisAnalysisService;
//import com.shcd.aistcp.util.AisAnalysisUtil;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.context.annotation.Bean;
//import org.springframework.context.annotation.Configuration;
//import org.springframework.integration.annotation.ServiceActivator;
//import org.springframework.integration.channel.DirectChannel;
//import org.springframework.integration.ip.tcp.TcpInboundGateway;
//import org.springframework.integration.ip.tcp.connection.AbstractServerConnectionFactory;
//import org.springframework.integration.ip.tcp.connection.TcpNetServerConnectionFactory;
//import org.springframework.integration.ip.tcp.serializer.ByteArrayLfSerializer;
//import org.springframework.messaging.MessageChannel;
//import org.springframework.messaging.MessageHandler;
//
//import javax.annotation.PostConstruct;
//import java.io.BufferedReader;
//import java.io.IOException;
//import java.io.InputStreamReader;
//import java.io.PrintWriter;
//import java.net.ServerSocket;
//import java.net.Socket;
//
///**
// * 类名:@Name - TcpServerConfig
// * 功能描述:@Function Description<>
// * 日期:@Date - 2025/1/21 10:50
// * 作者:@Created by zrj
// */
//@Configuration
//@Slf4j
//public class TcpServerConfig {
//    @Value("${tcp.server.port}")
//    private int port;
//
//
//    @Autowired
//    private AisAnalysisService aisAnalysisService;
//
//    @Autowired
//    private AisAnalysisUtil aisAnalysisUtil;
//
//    @PostConstruct
//    public void messageHandler() {
//        try (ServerSocket serverSocket = new ServerSocket(port)) {
//            System.out.println("服务器启动，监听端口：" + port);
//            while (true) {
//                // 等待客户端连接
//                Socket clientSocket = serverSocket.accept();
//                // 为每个客户端连接创建一个新线程处理
//                new Thread(() -> {
//                    try {
//                        System.out.println("客户端已连接：" + clientSocket.getInetAddress());
//                        BufferedReader in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
//                        PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
//                        String clientMessage;
//                        while ((clientMessage = in.readLine())!= null) {
//                            log.info("解析前 " +clientMessage);
//                            // 处理接收到的数据，这里可以添加业务逻辑
//                            BoatInfoEntity boatInfoEntity = aisAnalysisUtil.explanation(clientMessage);
//                            aisAnalysisService.saveAisAnalysis(boatInfoEntity);
//                        }
//                    } catch (IOException e) {
//                        System.out.println("客户端连接异常：" + e.getMessage());
//                    } finally {
//                        try {
//                            clientSocket.close();
//                        } catch (IOException e) {
//                            System.out.println("关闭客户端连接异常：" + e.getMessage());
//                        }
//                    }
//                }).start();
//            }
//        } catch (IOException e) {
//            System.out.println("服务器启动失败：" + e.getMessage());
//        }
//    }
//}
